package applet.resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import wwc.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import salsa.resources.ErrorService;

public class AppletError extends UniversalActor implements ErrorService {
	public static void main(String args[]) {
		AppletError instance = new AppletError();
		Object[] _arguments = { args };
		Message message = new Message( null, instance, "act", _arguments, null, null );
		instance.send( message );
	}

	public AppletError() {
		State state = new State();
		state.updateSelf(this);
	}
	public class State extends UniversalActor.State {
		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if ( !(e.getCause() instanceof CurrentContinuationException) ) {
							continue;
						} else {
							sendGeneratedMessages();
							return;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}
			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("	Sent by: " + message.getSource().toString());
			} else System.err.println("	Sent by: unknown");
			System.err.println("	Received by actor: " + toString());
			System.err.println("	Message: " + message.toString());
			System.err.println("	Did not match any of the following: ");
			if (matches == null) {
				System.err.println("		No messages with the same name found.");
				return;
		}
			for (int i = 0; i < matches.length; i++) {
				System.err.print("		Method: " + matches[i].getName() + "( ");
				Class[] parTypes = matches[i].getParameterTypes();
				for (int j = 0; j < parTypes.length; j++) {
					System.err.print(parTypes[j].getName() + " ");
				}
				System.err.println(")");
			}
		}

		public State(){
			super();
			try {
				Method[] declaredMethods = Class.forName("applet.resources.AppletError$State").getDeclaredMethods();
				for (int i = 0; i < declaredMethods.length; i++) {
					addMethod( declaredMethods[i].getName(), declaredMethods[i] );
				}
			} catch (Exception e) {
				System.err.println("Error generating methods for invocation, something is horribly wrong.");
				System.err.println("	Actor: " + toString() );
				System.err.println("	Error: " + e);
				e.printStackTrace();
			}
			this.reName("/system/appletError");
			RunTime.removedUniversalActor();
			sendGeneratedMessages();
		}
		public void print(Object p) {
			System.err.print(p);
		}
		public void print(boolean p) {
			System.err.print(p);
		}
		public void print(char p) {
			System.err.print(p);
		}
		public void print(byte p) {
			System.err.print(p);
		}
		public void print(short p) {
			System.err.print(p);
		}
		public void print(int p) {
			System.err.print(p);
		}
		public void print(long p) {
			System.err.print(p);
		}
		public void print(float p) {
			System.err.print(p);
		}
		public void print(double p) {
			System.err.print(p);
		}
		public void println(Object p) {
			System.err.println(p);
		}
		public void println(boolean p) {
			System.err.println(p);
		}
		public void println(char p) {
			System.err.println(p);
		}
		public void println(byte p) {
			System.err.println(p);
		}
		public void println(short p) {
			System.err.println(p);
		}
		public void println(int p) {
			System.err.println(p);
		}
		public void println(long p) {
			System.err.println(p);
		}
		public void println(float p) {
			System.err.println(p);
		}
		public void println(double p) {
			System.err.println(p);
		}
		public void println() {
			System.err.println();
		}
	}
}