package applet.resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import wwc.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.net.*;
import java.io.*;
import java.util.Hashtable;
import salsa.resources.StorageService;

public class AppletStorage extends UniversalActor implements StorageService {
	public static void main(String args[]) {
		AppletStorage instance = new AppletStorage();
		Object[] _arguments = { args };
		Message message = new Message( null, instance, "act", _arguments, null, null );
		instance.send( message );
	}

	public AppletStorage() {
		State state = new State();
		state.updateSelf(this);
	}
	public class State extends UniversalActor.State {
		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if ( !(e.getCause() instanceof CurrentContinuationException) ) {
							continue;
						} else {
							sendGeneratedMessages();
							return;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}
			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("	Sent by: " + message.getSource().toString());
			} else System.err.println("	Sent by: unknown");
			System.err.println("	Received by actor: " + toString());
			System.err.println("	Message: " + message.toString());
			System.err.println("	Did not match any of the following: ");
			if (matches == null) {
				System.err.println("		No messages with the same name found.");
				return;
		}
			for (int i = 0; i < matches.length; i++) {
				System.err.print("		Method: " + matches[i].getName() + "( ");
				Class[] parTypes = matches[i].getParameterTypes();
				for (int j = 0; j < parTypes.length; j++) {
					System.err.print(parTypes[j].getName() + " ");
				}
				System.err.println(")");
			}
		}

		Hashtable fileNames = new Hashtable();
		Hashtable messagesStored = new Hashtable();
		int generatedFile = 0;
		public State(){
			super();
			try {
				Method[] declaredMethods = Class.forName("applet.resources.AppletStorage$State").getDeclaredMethods();
				for (int i = 0; i < declaredMethods.length; i++) {
					addMethod( declaredMethods[i].getName(), declaredMethods[i] );
				}
			} catch (Exception e) {
				System.err.println("Error generating methods for invocation, something is horribly wrong.");
				System.err.println("	Actor: " + toString() );
				System.err.println("	Error: " + e);
				e.printStackTrace();
			}
			sendGeneratedMessages();
		}
		public void storeActor(Actor actor) {
			String filename = "" + generatedFile;
			fileNames.put(actor.getUAN(), filename);
			messagesStored.put(actor.getUAN(), new Integer(0));
			{
				// store(actor, filename)
				{
					Object _arguments[] = { actor, filename };
					Message message = new Message( self, self, "store", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void restoreActor(String filename) {
			Actor actor = (Actor) get(filename);
			Integer messages = (Integer) messagesStored.get(actor.getUAN());
			if (actor == null | messages == null) {
				System.err.println("AppletStorage error:");
				System.err.println("\tRestoring an  unknown target actor");
				System.err.println("\tFrom file: " + filename);
				return;
			}
			for (int i = 0; i < messages.intValue(); i++){
				actor.send((Message) get(filename + "_" + i));
			}
			actor.start();
			fileNames.remove(actor.getUAN());
			messagesStored.remove(actor.getUAN());
		}
		public void storeMessage(Message message) {
			UAN uan = message.getTarget().getUAN();
			if (uan == null) {
			}
			String filename = (String) fileNames.get(uan);
			Integer messageNumber = (Integer) messagesStored.get(uan);
			if (filename == null || messageNumber == null) {
				System.err.println("AppletStorage error:");
				System.err.println("\tStoring a message with an unknown target actor");
				System.err.println("\tMessage will be lost");
				System.err.println("\tMessage: " + message.toString());
				return;
			}
			this.store(message, filename + "_" + messageNumber);
			messagesStored.put(uan, new Integer(messageNumber.intValue() + 1));
		}
		public void store(Object object, String filename) {
			try {
				ObjectOutputStream outStream = new ObjectOutputStream(new FileOutputStream(filename));
				outStream.writeObject(object);
				outStream.close();
			}
			catch (IOException e) {
				System.err.println("StorageHandler exception: ");
				System.err.println("\tError serializing object to file: " + filename);
				System.err.println("\tObject = " + object.toString());
				System.err.println("\t" + e);
			}

		}
		public Object get(String filename) {
			Object object = null;
			try {
				ObjectInputStream inStream = new ObjectInputStream(new FileInputStream(filename));
				inStream.readObject();
				inStream.close();
			}
			catch (IOException e) {
				System.err.println("AppletStorage exception: ");
				System.err.println("\tError serializing object from file: " + filename);
				System.err.println("\t" + e);
			}
			catch (ClassNotFoundException e) {
				System.err.println("AppletStorage exception: ");
				System.err.println("\tObject class not found for: " + filename);
				System.err.println("\t" + e);
			}

			return object;
		}
	}
}