package examples.cell;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class MovingCellTester extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		MovingCellTester instance = (MovingCellTester)new MovingCellTester(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new MovingCellTester(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return MovingCellTester.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new MovingCellTester(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return MovingCellTester.getReferenceByLocation(new UAL(ual)); }
	public MovingCellTester(boolean o, UAN __uan)	{ super(__uan); }
	public MovingCellTester(boolean o, UAL __ual)	{ super(__ual); }

	public MovingCellTester(UAN __uan)	{ this(__uan, null); }
	public MovingCellTester(UAL __ual)	{ this(null, __ual); }
	public MovingCellTester()		{ this(null, null);  }
	public MovingCellTester(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.cell.MovingCellTester");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public MovingCellTester self;
		public void updateSelf(ActorReference actorReference) {
			self = (MovingCellTester)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.cell.MovingCellTester$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		public void act(String args[]) {
			if (args.length!=3) {
				{
					// standardOutput<-println("Usage: java examples.cell.MovingCellTester <UAN> <UAL1> <UAL2>")
					{
						Object _arguments[] = { "Usage: java examples.cell.MovingCellTester <UAN> <UAL1> <UAL2>" };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
				return;
			}
			Cell c = ((Cell)new Cell().construct(new Integer(5)));
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				Token token_2_3 = new Token();
				Token token_2_4 = new Token();
				Token token_2_5 = new Token();
				Token token_2_6 = new Token();
				Token token_2_7 = new Token();
				Token token_2_8 = new Token();
				Token token_2_9 = new Token();
				Token token_2_10 = new Token();
				Token token_2_11 = new Token();
				// c<-bind(args[0], args[1])
				{
					Object _arguments[] = { args[0], args[1] };
					Message message = new Message( self, c, "bind", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// standardOutput<-print("Initial Value:")
				{
					Object _arguments[] = { "Initial Value:" };
					Message message = new Message( self, standardOutput, "print", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// c<-get()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, c, "get", _arguments, token_2_1, token_2_2 );
					__messages.add( message );
				}
				// standardOutput<-println()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_2, token_2_3 );
					__messages.add( message );
				}
				// c<-set(new Integer(10))
				{
					Object _arguments[] = { new Integer(10) };
					Message message = new Message( self, c, "set", _arguments, token_2_3, token_2_4 );
					__messages.add( message );
				}
				// standardOutput<-print("New Value:")
				{
					Object _arguments[] = { "New Value:" };
					Message message = new Message( self, standardOutput, "print", _arguments, token_2_4, token_2_5 );
					__messages.add( message );
				}
				// c<-get()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, c, "get", _arguments, token_2_5, token_2_6 );
					__messages.add( message );
				}
				// standardOutput<-println()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_6, token_2_7 );
					__messages.add( message );
				}
				// c<-migrate(args[2])
				{
					Object _arguments[] = { args[2] };
					Message message = new Message( self, c, "migrate", _arguments, token_2_7, token_2_8 );
					__messages.add( message );
				}
				// c<-set(new Integer(20))
				{
					Object _arguments[] = { new Integer(20) };
					Message message = new Message( self, c, "set", _arguments, token_2_8, token_2_9 );
					__messages.add( message );
				}
				// standardOutput<-print("New Value at New Location:")
				{
					Object _arguments[] = { "New Value at New Location:" };
					Message message = new Message( self, standardOutput, "print", _arguments, token_2_9, token_2_10 );
					__messages.add( message );
				}
				// c<-get()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, c, "get", _arguments, token_2_10, token_2_11 );
					__messages.add( message );
				}
				// standardOutput<-println()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_11, null );
					__messages.add( message );
				}
			}
		}
	}
}