package examples.chat;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class Chat extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Chat instance = (Chat)new Chat(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Chat(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Chat.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Chat(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Chat.getReferenceByLocation(new UAL(ual)); }
	public Chat(boolean o, UAN __uan)	{ super(__uan); }
	public Chat(boolean o, UAL __ual)	{ super(__ual); }

	public Chat(UAN __uan)	{ this(__uan, null); }
	public Chat(UAL __ual)	{ this(null, __ual); }
	public Chat()		{ this(null, null);  }
	public Chat(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.chat.Chat");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Chat self;
		public void updateSelf(ActorReference actorReference) {
			self = (Chat)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.chat.Chat$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		String myUAN;
		public void chatSession(Speaker s1, Speaker s2) {
			for (int i = 0; i<3; i++){
				{
					Token token_3_0 = new Token();
					// s1<-talk(myUAN, "Hey what's up?  ")
					{
						Object _arguments[] = { myUAN, "Hey what's up?  " };
						Message message = new Message( self, s1, "talk", _arguments, null, token_3_0 );
						__messages.add( message );
					}
					// s2<-talk(myUAN, "I am ok thanks!  ")
					{
						Object _arguments[] = { myUAN, "I am ok thanks!  " };
						Message message = new Message( self, s2, "talk", _arguments, token_3_0, null );
						__messages.add( message );
					}
				}
			}
		}
		public void reply(String replyMsg) {
			{
				// standardOutput<-println(replyMsg)
				{
					Object _arguments[] = { replyMsg };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void act(String args[]) {
			if (args.length!=3) {
				{
					// standardOutput<-println("Usage: java examples.chat.Sender <UAN> <friendUAN> <myUAN>")
					{
						Object _arguments[] = { "Usage: java examples.chat.Sender <UAN> <friendUAN> <myUAN>" };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
				return;
			}
			myUAN = args[2];
			{
				// bind(myUAN)
				{
					Object _arguments[] = { myUAN };
					Message message = new Message( self, self, "bind", _arguments, null, null );
					__messages.add( message );
				}
			}
			UniversalActor speaker1 = (UniversalActor)UniversalActor.getReferenceByName(new UAN(args[0]));
			UniversalActor speaker2 = (UniversalActor)UniversalActor.getReferenceByName(new UAN(args[1]));
			{
				// chatSession(speaker1, speaker2)
				{
					Object _arguments[] = { speaker1, speaker2 };
					Message message = new Message( self, self, "chatSession", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
	}
}