// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.*;

public class Heat extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Heat instance = (Heat)new Heat(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Heat(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Heat.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Heat(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Heat.getReferenceByLocation(new UAL(ual)); }
	public Heat(boolean o, UAN __uan)	{ super(__uan); }
	public Heat(boolean o, UAL __ual)	{ super(__ual); }

	public Heat(UAN __uan)	{ this(__uan, null); }
	public Heat(UAL __ual)	{ this(null, __ual); }
	public Heat()		{ this(null, null);  }
	public Heat(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "Heat");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Heat self;
		public void updateSelf(ActorReference actorReference) {
			self = (Heat)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "Heat$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		int iterations = 1024;
		int x = 126;
		int y = 126;
		int actors = 4;
		String nameServer = "jupiter.wcl.cs.rpi.edu";
		String theatersFile = "wcl.txt";
		String fileName = "heat-salsa.map";
		public double[][] createInitialData() {
			double[][] data = new double[x][];
			for (int i = 0; i<x; i++){
				data[i] = new double[y];
				for (int j = 0; j<y; j++){
					data[i][j] = 20.0;
					if (i==0||j==0||i==x-1||j==y-1) data[i][j] = 20.0;
					if (j==0&&i>x/4&&i<3*x/4) data[i][j] = 100.0;
				}
			}
			return data;
		}
		public double[][] doWork(double[][] data, int iterations, int noActors, String nameServer, String theatersFile) {
			double[][] next = new double[x][];
			for (int i = 0; i<x; i++){
				next[i] = new double[y];
				System.arraycopy(data[i], 0, next[i], 0, y);
			}
			long initialTime = System.currentTimeMillis();
			for (int k = 0; k<iterations; k++){
				for (int i = 1; i<x-1; i++)for (int j = 1; j<y-1; j++)next[i][j] = 0.25*(data[i-1][j]+data[i][j-1]+data[i+1][j]+data[i][j+1]);
				double[][] temp = next;
				next = data;
				data = temp;
			}
			long finalTime = System.currentTimeMillis();
			long runningTime = finalTime-initialTime;
			double processingRate = 1.0*iterations*(x-2)*(y-2)/runningTime;
			{
				// standardOutput<-println("Time for "+iterations+" iterations on "+(x-2)+","+(y-2)+" grid: "+runningTime+" ms.")
				{
					Object _arguments[] = { "Time for "+iterations+" iterations on "+(x-2)+","+(y-2)+" grid: "+runningTime+" ms." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			{
				// standardOutput<-println("Execution rate: "+processingRate+" points/ms")
				{
					Object _arguments[] = { "Execution rate: "+processingRate+" points/ms" };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			return data;
		}
		public void produceFile(double[][] data, String fileName) {
			try {
				PrintWriter out = new PrintWriter(new FileWriter(fileName));
				out.println(x+" "+y);
				for (int i = 0; i<x; i++){
					for (int j = 0; j<y; j++)out.println(data[i][j]);
				}
				out.flush();
				out.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file "+fileName+" for writing.")
					{
						Object _arguments[] = { "[error] Can't open the file "+fileName+" for writing." };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}

		}
		public void act(String args[]) {
			int argc = args.length;
			if (argc>=1) iterations = Integer.parseInt(args[0]);
			if (argc>=2) x = Integer.parseInt(args[1]);
			if (argc>=3) y = Integer.parseInt(args[2]);
			if (argc>=4) actors = Integer.parseInt(args[3]);
			if (argc>=5) nameServer = args[4];
			if (argc>=6) theatersFile = args[5];
			if (argc>=7) fileName = args[6];
			x += 2;
			y += 2;
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// createInitialData()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "createInitialData", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// doWork(token, new Integer(iterations), new Integer(actors), nameServer, theatersFile)
				{
					Object _arguments[] = { token_2_0, new Integer(iterations), new Integer(actors), nameServer, theatersFile };
					Message message = new Message( self, self, "doWork", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// produceFile(token, fileName)
				{
					Object _arguments[] = { token_2_1, fileName };
					Message message = new Message( self, self, "produceFile", _arguments, token_2_1, null );
					__messages.add( message );
				}
			}
		}
	}
}