package examples.heat;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.*;

public class HeatWorker extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		HeatWorker instance = (HeatWorker)new HeatWorker(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new HeatWorker(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return HeatWorker.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new HeatWorker(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return HeatWorker.getReferenceByLocation(new UAL(ual)); }
	public HeatWorker(boolean o, UAN __uan)	{ super(__uan); }
	public HeatWorker(boolean o, UAL __ual)	{ super(__ual); }

	public HeatWorker(UAN __uan)	{ this(__uan, null); }
	public HeatWorker(UAL __ual)	{ this(null, __ual); }
	public HeatWorker()		{ this(null, null);  }
	public HeatWorker(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.heat.HeatWorker");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct (double[][] inData) {
		Object[] __arguments = { inData };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public HeatWorker self;
		public void updateSelf(ActorReference actorReference) {
			self = (HeatWorker)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.heat.HeatWorker$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		int x;
		int y;
		double[][] data;
		double[][] next;
		HeatWorker top;
		HeatWorker bottom;
		boolean topOk = false;
		boolean bottomOk = false;
		void construct(double[][] inData){
			x = inData.length+2;
			y = inData[0].length;
			data = new double[x][];
			data[0] = new double[y];
			data[x-1] = new double[y];
			for (int j = 0; j<y; j++){
				data[0][j] = data[x-1][j]=-1;
			}
			for (int i = 0; i<x-2; i++){
				data[i+1] = new double[y];
				System.arraycopy(inData[i], 0, data[i+1], 0, y);
			}
			next = new double[x][];
			for (int i = 0; i<x; i++){
				next[i] = new double[y];
				System.arraycopy(data[i], 0, next[i], 0, y);
			}
		}
		public void connectTop(HeatWorker w) {
			top = w;
			{
				// top<-bottomRow(data[0])
				{
					Object _arguments[] = { data[0] };
					Message message = new Message( self, top, "bottomRow", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void connectBottom(HeatWorker w) {
			bottom = w;
			{
				// bottom<-topRow(data[x-1])
				{
					Object _arguments[] = { data[x-1] };
					Message message = new Message( self, bottom, "topRow", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void topRow(double[] row) {
			System.arraycopy(row, 0, data[0], 0, y);
			topOk = true;
		}
		public void bottomRow(double[] row) {
			System.arraycopy(row, 0, data[x-1], 0, y);
			bottomOk = true;
		}
		public double[][] doWork(int iterations) {
			if (((bottom==null)||(bottomOk))&&((top==null)||(topOk))) {
				int from = (top==null?2:1);
				int to = (bottom==null?x-2:x-1);
				for (int i = from; i<to; i++)for (int j = 1; j<y-1; j++)next[i][j] = 0.25*(data[i-1][j]+data[i][j-1]+data[i+1][j]+data[i][j+1]);
				double[][] temp = next;
				next = data;
				data = temp;
				if (top!=null) 				{
					// top<-bottomRow(data[0])
					{
						Object _arguments[] = { data[0] };
						Message message = new Message( self, top, "bottomRow", _arguments, null, null );
						__messages.add( message );
					}
				}
				if (bottom!=null) 				{
					// bottom<-topRow(data[x-1])
					{
						Object _arguments[] = { data[x-1] };
						Message message = new Message( self, bottom, "topRow", _arguments, null, null );
						__messages.add( message );
					}
				}
				topOk = false;
				bottomOk = false;
				if (iterations==0) {
					double[][] results = new double[x-2][];
					System.arraycopy(data, 1, results, 0, x-2);
					return results;
				}
				else {
					{
						// doWork(new Integer(iterations-1))
						{
							Object _arguments[] = { new Integer(iterations-1) };
							Message message = new Message( self, self, "doWork", _arguments, null, currentMessage.getContinuationToken() );
							__messages.add( message );
						}
						throw new CurrentContinuationException();
					}
				}
			}
			else {
				{
					// doWork(new Integer(iterations))
					{
						Object _arguments[] = { new Integer(iterations) };
						Message message = new Message( self, self, "doWork", _arguments, null, currentMessage.getContinuationToken() );
						__messages.add( message );
					}
					throw new CurrentContinuationException();
				}
			}
		}
	}
}