package examples.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class TokenPrinter extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		TokenPrinter instance = (TokenPrinter)new TokenPrinter(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new TokenPrinter(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return TokenPrinter.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new TokenPrinter(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return TokenPrinter.getReferenceByLocation(new UAL(ual)); }
	public TokenPrinter(boolean o, UAN __uan)	{ super(__uan); }
	public TokenPrinter(boolean o, UAL __ual)	{ super(__ual); }

	public TokenPrinter(UAN __uan)	{ this(__uan, null); }
	public TokenPrinter(UAL __ual)	{ this(null, __ual); }
	public TokenPrinter()		{ this(null, null);  }
	public TokenPrinter(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.language.TokenPrinter");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public TokenPrinter self;
		public void updateSelf(ActorReference actorReference) {
			self = (TokenPrinter)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.language.TokenPrinter$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		public int compute() {
			return 5;
		}
		public String computeString() {
			return "a string";
		}
		public Object computeObject() {
			return new Integer(5);
		}
		public void print(int number) {
			{
				// standardOutput<-println(new Integer(number+2))
				{
					Object _arguments[] = { new Integer(number+2) };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void print(Integer number) {
			{
				// standardOutput<-println(number)
				{
					Object _arguments[] = { number };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void print(String string) {
			{
				// standardOutput<-println(string+" indeed.")
				{
					Object _arguments[] = { string+" indeed." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void print(Object object) {
			{
				// standardOutput<-println("Object:"+object)
				{
					Object _arguments[] = { "Object:"+object };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void act(String[] args) {
			{
				Token token_2_0 = new Token();
				// compute()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "compute", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// print(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "print", _arguments, token_2_0, null );
					__messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// computeString()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "computeString", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// print(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "print", _arguments, token_2_0, null );
					__messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// computeObject()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "computeObject", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// print(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "print", _arguments, token_2_0, null );
					__messages.add( message );
				}
			}
			int i = 0;
			String s = "s";
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				Token token_2_3 = new Token();
				// print(1)
				{
					Object _arguments[] = { new Integer(1) };
					Message message = new Message( self, self, "print", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// print(s)
				{
					Object _arguments[] = { s };
					Message message = new Message( self, self, "print", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// print("a"+"b")
				{
					Object _arguments[] = { "a"+"b" };
					Message message = new Message( self, self, "print", _arguments, token_2_1, token_2_2 );
					__messages.add( message );
				}
				// print(new Integer(1))
				{
					Object _arguments[] = { new Integer(1) };
					Message message = new Message( self, self, "print", _arguments, token_2_2, token_2_3 );
					__messages.add( message );
				}
				// print(new Integer(1+1))
				{
					Object _arguments[] = { new Integer(1+1) };
					Message message = new Message( self, self, "print", _arguments, token_2_3, null );
					__messages.add( message );
				}
			}
		}
	}
}