package examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import salsa.naming.*;

public class LargeUniversalActor extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		LargeUniversalActor instance = (LargeUniversalActor)new LargeUniversalActor(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new LargeUniversalActor(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return LargeUniversalActor.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new LargeUniversalActor(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return LargeUniversalActor.getReferenceByLocation(new UAL(ual)); }
	public LargeUniversalActor(boolean o, UAN __uan)	{ super(__uan); }
	public LargeUniversalActor(boolean o, UAL __ual)	{ super(__ual); }

	public LargeUniversalActor(UAN __uan)	{ this(__uan, null); }
	public LargeUniversalActor(UAL __ual)	{ this(null, __ual); }
	public LargeUniversalActor()		{ this(null, null);  }
	public LargeUniversalActor(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.migration.LargeUniversalActor");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct () {
		Object[] __arguments = {  };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public UniversalActor construct (int size) {
		Object[] __arguments = { new Integer(size) };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public LargeUniversalActor self;
		public void updateSelf(ActorReference actorReference) {
			self = (LargeUniversalActor)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.migration.LargeUniversalActor$State" );
			addMethodsForClasses();
		}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		byte[] largeData;
		void construct(){
		}
		void construct(int size){
			largeData = new byte[size];
		}
		public void act(String args[]) {
			try {
				int howMany = Integer.parseInt(args[0]);
				int size = Integer.parseInt(args[1]);
				UAN uan = new UAN(args[2]);
				UAL ual = new UAL(args[3]);
				long initialTime = System.currentTimeMillis();
				for (int i = 0; i<howMany; i++){
					LargeUniversalActor a = ((LargeUniversalActor)new LargeUniversalActor().construct(size));
					{
						// a<-bind(uan, ual)
						{
							Object _arguments[] = { uan, ual };
							Message message = new Message( self, a, "bind", _arguments, null, null );
							__messages.add( message );
						}
					}
				}
				long finalTime = System.currentTimeMillis();
				{
					// standardOutput<-println(howMany+" Large actor creations.  "+"Time taken (ms): "+(finalTime-initialTime))
					{
						Object _arguments[] = { howMany+" Large actor creations.  "+"Time taken (ms): "+(finalTime-initialTime) };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			catch (ArrayIndexOutOfBoundsException e) {
				{
					// standardOutput<-println("Usage: java migration.LargeUniversalActor "+"<howMany> <size> <UAN> <UAL>")
					{
						Object _arguments[] = { "Usage: java migration.LargeUniversalActor "+"<howMany> <size> <UAN> <UAL>" };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			catch (Exception e) {
				{
					// standardOutput<-println(e)
					{
						Object _arguments[] = { e };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}

		}
	}
}