package examples.multicast;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class Multicast extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Multicast instance = (Multicast)new Multicast(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Multicast(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Multicast.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Multicast(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Multicast.getReferenceByLocation(new UAL(ual)); }
	public Multicast(boolean o, UAN __uan)	{ super(__uan); }
	public Multicast(boolean o, UAL __ual)	{ super(__ual); }

	public Multicast(UAN __uan)	{ this(__uan, null); }
	public Multicast(UAL __ual)	{ this(null, __ual); }
	public Multicast()		{ this(null, null);  }
	public Multicast(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.multicast.Multicast");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Multicast self;
		public void updateSelf(ActorReference actorReference) {
			self = (Multicast)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.multicast.Multicast$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		SimpleActor[] actors;
		public void setActors(SimpleActor[] actors) {
			this.actors = actors;
		}
		public long go() {
			long initialTime = System.currentTimeMillis();
			for (int i = 0; i<actors.length; i++){
				{
					// actors[i]<-m()
					{
						Object _arguments[] = {  };
						Message message = new Message( self, actors[i], "m", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			return System.currentTimeMillis()-initialTime;
		}
		public void act(String[] args) {
			int howMany = Integer.parseInt(args[0]);
			SimpleActor[] actors = new SimpleActor[howMany];
			for (int i = 0; i<howMany; i++){
				actors[i] = ((SimpleActor)new SimpleActor().construct());
			}
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				Token token_2_3 = new Token();
				// setActors(actors)
				{
					Object _arguments[] = { actors };
					Message message = new Message( self, self, "setActors", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// standardOutput<-print("Time for multicast: ")
				{
					Object _arguments[] = { "Time for multicast: " };
					Message message = new Message( self, standardOutput, "print", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// go()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "go", _arguments, token_2_1, token_2_2 );
					__messages.add( message );
				}
				// standardOutput<-print(token)
				{
					Object _arguments[] = { token_2_2 };
					Message message = new Message( self, standardOutput, "print", _arguments, token_2_2, token_2_3 );
					__messages.add( message );
				}
				// standardOutput<-println(" ms.")
				{
					Object _arguments[] = { " ms." };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_3, null );
					__messages.add( message );
				}
			}
		}
	}
}