package examples.ping;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class Ping extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Ping instance = (Ping)new Ping(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Ping(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Ping.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Ping(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Ping.getReferenceByLocation(new UAL(ual)); }
	public Ping(boolean o, UAN __uan)	{ super(__uan); }
	public Ping(boolean o, UAL __ual)	{ super(__ual); }

	public Ping(UAN __uan)	{ this(__uan, null); }
	public Ping(UAL __ual)	{ this(null, __ual); }
	public Ping()		{ this(null, null);  }
	public Ping(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.ping.Ping");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Ping self;
		public void updateSelf(ActorReference actorReference) {
			self = (Ping)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.ping.Ping$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		long startTime;
		public void ping(String localUAL, String remoteUAL) {
			{
				// standardOutput<-println("Sending PING to actor at "+remoteUAL)
				{
					Object _arguments[] = { "Sending PING to actor at "+remoteUAL };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			EchoAgent a = ((EchoAgent)new EchoAgent().construct());
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				// a<-getReferenceByLocation(remoteUAL)
				{
					Object _arguments[] = { remoteUAL };
					Message message = new Message( self, a, "getReferenceByLocation", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// a<-registerUAL(localUAL)
				{
					Object _arguments[] = { localUAL };
					Message message = new Message( self, a, "registerUAL", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// startTime()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "startTime", _arguments, token_2_1, token_2_2 );
					__messages.add( message );
				}
				// a<-echo()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, a, "echo", _arguments, token_2_2, null );
					__messages.add( message );
				}
			}
		}
		public void startTime() {
			startTime = System.currentTimeMillis();
		}
		public void pong() {
			long roundTrip = System.currentTimeMillis()-startTime;
			{
				Token token_2_0 = new Token();
				// standardOutput<-println("Received ECHO within "+String.valueOf(roundTrip)+" ms.")
				{
					Object _arguments[] = { "Received ECHO within "+String.valueOf(roundTrip)+" ms." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// standardOutput<-println("Message sending avg time: "+String.valueOf(roundTrip/2)+" ms.")
				{
					Object _arguments[] = { "Message sending avg time: "+String.valueOf(roundTrip/2)+" ms." };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_0, null );
					__messages.add( message );
				}
			}
		}
		public void act(String args[]) {
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// bind(args[0], args[1])
				{
					Object _arguments[] = { args[0], args[1] };
					Message message = new Message( self, self, "bind", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// migrate(args[1])
				{
					Object _arguments[] = { args[1] };
					Message message = new Message( self, self, "migrate", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// ping(args[1], args[2])
				{
					Object _arguments[] = { args[1], args[2] };
					Message message = new Message( self, self, "ping", _arguments, token_2_1, null );
					__messages.add( message );
				}
			}
		}
	}
}