package examples.trap;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.*;
import java.util.*;

public class Trap extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Trap instance = (Trap)new Trap(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Trap(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Trap.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Trap(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Trap.getReferenceByLocation(new UAL(ual)); }
	public Trap(boolean o, UAN __uan)	{ super(__uan); }
	public Trap(boolean o, UAL __ual)	{ super(__ual); }

	public Trap(UAN __uan)	{ this(__uan, null); }
	public Trap(UAL __ual)	{ this(null, __ual); }
	public Trap()		{ this(null, null);  }
	public Trap(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.trap.Trap");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Trap self;
		public void updateSelf(ActorReference actorReference) {
			self = (Trap)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.trap.Trap$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		int noActors = 2;
		double a = 0.0;
		double b = 1.0;
		int n = 1024;
		long initialTime;
		String nameServer = "jupiter.wcl.cs.rpi.edu";
		String theatersFile = "theaters.txt";
		public void act(String args[]) {
			int argc = args.length;
			if (argc>=1) a = Double.valueOf(args[0]).doubleValue();
			if (argc>=2) b = Double.valueOf(args[1]).doubleValue();
			if (argc>=3) n = Integer.parseInt(args[2]);
			if (argc>=4) noActors = Integer.parseInt(args[3]);
			if (argc>=5) nameServer = args[4];
			if (argc>=6) theatersFile = args[5];
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// DistributeWork()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "DistributeWork", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// displayResults(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "displayResults", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// endTimer()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "endTimer", _arguments, token_2_1, null );
					__messages.add( message );
				}
			}
		}
		public double[][] DistributeWork() {
			Double h = new Double((b-a)/n);
			Integer local_n = new Integer((int)(n/noActors));
			Double local_a;
			Double local_b;
			TrapWorker[] workers = new TrapWorker[noActors];
			for (int i = 0; i<noActors; i++){
				workers[i] = ((TrapWorker)new TrapWorker().construct());
			}
			Vector theaters = new Vector();
			String theater;
			try {
				BufferedReader in = new BufferedReader(new FileReader(theatersFile));
				while ((theater=in.readLine())!=null) {
					theaters.add(theater);
				}
				in.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file "+theatersFile+" for reading.")
					{
						Object _arguments[] = { "[error] Can't open the file "+theatersFile+" for reading." };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}

			for (int i = 0; i<noActors; i++){
				{
					// standardOutput<-println("Sending actor "+"uan://"+nameServer+":3030/a"+i+" to "+"rmsp://"+theaters.get(i%theaters.size())+"/a"+i)
					{
						Object _arguments[] = { "Sending actor "+"uan://"+nameServer+":3030/a"+i+" to "+"rmsp://"+theaters.get(i%theaters.size())+"/a"+i };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
				{
					// workers[i]<-bind("uan://"+nameServer+":3030/a"+i, "rmsp://"+theaters.get(i%theaters.size())+"/a"+i)
					{
						Object _arguments[] = { "uan://"+nameServer+":3030/a"+i, "rmsp://"+theaters.get(i%theaters.size())+"/a"+i };
						Message message = new Message( self, workers[i], "bind", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			{
				// standardOutput<-println(">>>>>>Starting the computation")
				{
					Object _arguments[] = { ">>>>>>Starting the computation" };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			initialTime = System.currentTimeMillis();
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<noActors; i++){
					System.out.println("sending work to worker "+i);
					local_a = new Double(a+i*local_n.doubleValue()*h.doubleValue());
					local_b = new Double(local_a.doubleValue()+local_n.doubleValue()*h.doubleValue());
					{
						// workers[i]<-trap(local_a, local_b, local_n, h)
						{
							Object _arguments[] = { local_a, local_b, local_n, h };
							Message message = new Message( self, workers[i], "trap", _arguments, null, token_2_0 );
							__messages.add( message );
						}
					}
				}
				token_2_0.createJoinDirector();
				// addUpIntegrals(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "addUpIntegrals", _arguments, token_2_0, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public void endTimer() {
			long finalTime = System.currentTimeMillis();
			long runningTime = finalTime-initialTime;
			{
				// standardOutput<-println("Running time for Trapezoidal approximation is "+runningTime+" ms.")
				{
					Object _arguments[] = { "Running time for Trapezoidal approximation is "+runningTime+" ms." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public Double addUpIntegrals(Object[] results) {
			double total = 0.0;
			for (int i = 0; i<results.length; i++){
				total += ((Double)results[i]).doubleValue();
			}
			return new Double(total);
		}
		public void displayResults(Double result) {
			{
				// standardOutput<-println("With n = "+n+" trapezoids, our estimate of the integral on ("+a+","+b+") ="+result.doubleValue()+"with error "+(result.doubleValue()-1.0e0))
				{
					Object _arguments[] = { "With n = "+n+" trapezoids, our estimate of the integral on ("+a+","+b+") ="+result.doubleValue()+"with error "+(result.doubleValue()-1.0e0) };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
	}
}