package examples.trap;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.*;

public class TrapWorker extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		TrapWorker instance = (TrapWorker)new TrapWorker(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new TrapWorker(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return TrapWorker.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new TrapWorker(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return TrapWorker.getReferenceByLocation(new UAL(ual)); }
	public TrapWorker(boolean o, UAN __uan)	{ super(__uan); }
	public TrapWorker(boolean o, UAL __ual)	{ super(__ual); }

	public TrapWorker(UAN __uan)	{ this(__uan, null); }
	public TrapWorker(UAL __ual)	{ this(null, __ual); }
	public TrapWorker()		{ this(null, null);  }
	public TrapWorker(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "examples.trap.TrapWorker");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public TrapWorker self;
		public void updateSelf(ActorReference actorReference) {
			self = (TrapWorker)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "examples.trap.TrapWorker$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		public Double trap(Double local_a, Double local_b, Integer local_n, Double h) {
			Token f_local_a = new Token("f_local_a");
			{
				// token f_local_a = f(local_a)
				{
					Object _arguments[] = { local_a };
					Message message = new Message( self, self, "f", _arguments, null, f_local_a );
					__messages.add( message );
				}
			}
			Token f_local_b = new Token("f_local_b");
			{
				// token f_local_b = f(local_b)
				{
					Object _arguments[] = { local_b };
					Message message = new Message( self, self, "f", _arguments, null, f_local_b );
					__messages.add( message );
				}
			}
			Token integral = new Token("integral");
			{
				// token integral = startIntegral(f_local_a, f_local_b)
				{
					Object _arguments[] = { f_local_a, f_local_b };
					Message message = new Message( self, self, "startIntegral", _arguments, null, integral );
					__messages.add( message );
				}
			}
			double x = local_a.doubleValue();
			for (int i = 1; i<=local_n.intValue()-1; i++, x += h.doubleValue()){
				Token f_x = new Token("f_x");
				{
					// token f_x = f(new Double(x))
					{
						Object _arguments[] = { new Double(x) };
						Message message = new Message( self, self, "f", _arguments, null, f_x );
						__messages.add( message );
					}
				}
				{
					// integral = add(integral, f_x)
					Token integral_next = new Token("add_next");
					{
						Object _arguments[] = { integral, f_x };
						Message message = new Message( self, self, "add", _arguments, null, integral_next );
						__messages.add( message );
					}
					integral = integral_next;
				}
			}
			{
				// multiply(integral, h)
				{
					Object _arguments[] = { integral, h };
					Message message = new Message( self, self, "multiply", _arguments, null, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public Double f(Double d) {
			double dv = d.doubleValue();
			return new Double(5*dv*dv*dv*dv);
		}
		public Double add(Double d, Double f) {
			double dv = d.doubleValue();
			double fv = f.doubleValue();
			return new Double(dv+fv);
		}
		public Double multiply(Double d, Double f) {
			double dv = d.doubleValue();
			double fv = f.doubleValue();
			return new Double(dv*fv);
		}
		public Double startIntegral(Double d, Double f) {
			return new Double((d.doubleValue()+f.doubleValue())/2.0);
		}
	}
}