/**
 * $Id: Actor.java,v 1.73 2004/02/01 11:49:52 deselt Exp $
 *
 * This is the Actor interface, used by the WWC and IO, as well as Local Salsa.
 */

package salsa.language;

import java.util.Vector;
import java.lang.reflect.Method;

import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;

public interface Actor {
	public UAN getUAN();
	public UAL getUAL();
	public void setUAL(UAL ual);

	public void start();
	public void destroy();
	public void process(Message message);
	public void putMessageInMailbox(Message message);
	public void sendGeneratedMessages();
	public void updateSelf(ActorReference actorReference);

	public Method[] getMatches(String methodName);
	public void addMethod(String methodName, Method method);

	public String toString();
        public boolean equals(Object o);
}
