/**
 * $Id: ActorReference.java,v 1.27 2004/02/01 11:49:52 deselt Exp $
 *
 * This is the main Actor class.
 */

package salsa.language;
import java.io.IOException;

import salsa.messaging.TheaterService;
import salsa.messaging.TransportService;
import salsa.naming.NamingService;
import salsa.naming.UAL;
import salsa.naming.UAN;

public interface ActorReference {

	public UAN getUAN();
	public void setUAN(UAN uan);
	public UAL getUAL();
	public void setUAL(UAL ual);

	/*
	 * All actor references require at least a construct method, to create the actor.
	 * this is generated by the SALSA compiler.
	 */
	public UniversalActor construct();
	public void createRemotely(UAN uan, UAL ual, String actorName);

	/* 
	 * The following cover local and remote message sending for Actors
	 */
	public void send(Message message);

	/*
	 * Methods for printing out the identity of an actor
	 */
	public String toString();
	public boolean equals(Object o);
}
