/*
	Code generation for the following grammar segment:
	
	BehaviorDeclaration := "behavior" <IDENTIFIER> ["extends" Name()] ["implements" Name() ("," Name())*] BehaviorBody()
*/


package salsac.definitions;

import salsac.*;
import java.util.Vector;

public class BehaviorDeclaration extends SimpleNode {

	public BehaviorDeclaration(int id) 			{ super(id); }
	public BehaviorDeclaration(SalsaParser p, int id)	{ super(p, id); }

	public String extendsName = null;
	public Vector implementNames = new Vector();

	public String getChildCode() {
		String code = "class " + getToken(1);					//"behavior <IDENTIFIER>"

		if (tokens.length == 2 || !getToken(2).image.equals("extends")) {
			String actorType = System.getProperty("actor");
			if (actorType == null) {
				extendsName = "UniversalActor";
				code += " extends UniversalActor ";
			} else {
				extendsName = actorType;
				code += " extends " + actorType + " ";
			}
		}

		int i = 2;
		for (; i < tokens.length; i++) {
			if ( getToken(i).image.equals("extends") ) {
				extendsName = getChild(i-2).getJavaCode();
				code += " " + getToken(i).image + " " + getChild(i-2).getJavaCode();
			} else if ( getToken(i).image.equals(",") ) {
				implementNames.add(getChild(i-2).getJavaCode());
				code += ", " + getChild(i-2).getJavaCode();
			} else if ( getToken(i).image.equals("implements") ) {
				code += "implements ";
				code += getChild(i-2).getJavaCode();
			}
		}
		SalsaCompiler.extendsName = extendsName;
		SalsaCompiler.implementNames = implementNames;
		SalsaCompiler.actorName = getToken(1).image;


		code += " " + getChild(i-2).getJavaCode();

		return code;
	}
}
