/* SALSA/World Wide Computer Porject
 *
 * Location Server - Universal Actor Name Daemon
 * Provides the location (Universal Actor Location) of an actor running on
 * the World Wide Computer from its name (Universal Actor Name).
 *
 * By Gregory Haik and Carlos Varela.  v0.1  June, 1999
 *
 */

package wwc.naming;


/**
 * Defines the constants of the Universal Actor Name Protocol v0.1.
 * Can not be instanciated.
 * 
 * Here are the requests associated with the responses it leads to :
 * GET  -> 200, 400, 404;
 * PUT  -> 201, 400;
 * DEL  -> 201, 400, 404.
 *
 * @version %I%, %G%
 * @author Gregory Haik, Carlos Varela
 */

public class UANProtocol {
/**
 * This private constructor guarantees that this class will never be instanciated.
 */    
    private UANProtocol() {}; 
 
    public static String VERSION = "UANP/0.1";
    
    public static String FOUND_STATUS_CODE     = "200";
    public static String MODIF_STATUS_CODE     = "201";
    public static String BAD_REQ_STATUS_CODE   = "400";
    public static String NOT_FOUND_STATUS_CODE = "404";

    
    public static String FOUND_STATUS_STR     = "Location Found";
    public static String MODIF_STATUS_STR     = "Database Modified";
    public static String BAD_REQ_STATUS_STR   = "Bad Request";
    public static String NOT_FOUND_STATUS_STR = "Name Not Found";

}
